////////////////////////////////////////
/**************************************/
/*                                    */
/* Michael Goldbuch; Jrgen Dffinger */
/*                                    */
/* Mikroprozessortechnik              */
/* APL / MAIN			              */
/* Version 1.0.0                      */
/* 2011-06-07                         */
/*                                    */
/**************************************/
////////////////////////////////////////



//	definitions for ATMega8
.include "m8def.inc"



/***************   Interupts   ***************/

rjmp RESET ; Reset Handler
reti; rjmp EXT_INT0 ; IRQ0 Handler
reti; rjmp EXT_INT1 ; IRQ1 Handler
reti; rjmp TIM2_COMP ; Timer2 Compare Handler
reti; rjmp TIM2_OVF ; Timer2 Overflow Handler
reti; rjmp TIM1_CAPT ; Timer1 Capture Handler
reti; rjmp TIM1_COMPA ; Timer1 CompareA Handler
reti; rjmp TIM1_COMPB ; Timer1 CompareB Handler
reti; rjmp TIM1_OVF ; Timer1 Overflow Handler
rjmp TIM0_OVF ; Timer0 Overflow Handler
reti; rjmp SPI_STC ; SPI Transfer Complete Handler
reti; rjmp USART_RXC ; USART RX Complete Handler
reti; rjmp USART_UDRE ; UDR Empty Handler
reti; rjmp USART_TXC ; USART TX Complete Handler
rjmp ADCI ; ADC Conversion Complete Handler
reti; rjmp EE_RDY ; EEPROM Ready Handler
reti; rjmp ANA_COMP ; Analog Comparator Handler
reti; rjmp TWSI ; Two-wire Serial Interface Handler
reti; rjmp SPM_RDY ; Store Program Memory Ready Handler



/***************   Includes   ***************/

.include "./includes/arithmetic.asm"
.include "./includes/USART.asm"	

.include "./includes/defs.asm"		; Enthlt Definitionen
.include "./includes/LED.asm"		; Unterprogramme zur Steuerung der LEDs
.include "./includes/ISR.asm"		; Interrupt Service Routines
.include "./includes/RESET.asm"		; RESET Unterprogramme
.include "./includes/RECEIVE.asm"	; RECEIVE Unterprogramme 
.include "./includes/FAHREN.asm"	; FAHREN Unterprogramme
.include "./includes/TRANSMIT.asm"	; TRANSMIT Unterprogramme



//***************   RESET   ***************/

RESET:


	// 	Stack initialisieren
	ldi R16,high(RAMEND)
	out sph,R16
	ldi R16,low(RAMEND)	
	out spl,R16	
	
	rcall USART_INIT	; USART initialisieren
	rcall ADC_INIT		; ADC initialisieren
	rcall MOTOR_INIT	; Motoren initialisieren fr Vorwrtsfahrt
	rcall ALL_LED_OFF	; alle LEDs abschalten
	rcall FRONT_LED_ON	; Front_LED einschalten
	rcall TIMER0_INIT	; Timer fr Timeout initialisieren

	sei					; globaler Interrupt enable

rjmp main
	


/***************   MAIN   ***************/

MAIN:

	rcall RECEIVE		; auf zu bertragende Daten warten und diese nach Empfang speichern
	rcall FAHREN		; nach empfangener Zeichenfolge zum nchsten Ziel fahren
	rcall TRANSMIT		; nach Ankunft am Zielort gespeicherte Zeichenfolge senden

rjmp MAIN







