////////////////////////////////////////
/**************************************/
/*                                    */
/* Michael Goldbuch; Jrgen Dffinger */
/*                                    */
/* Mikroprozessortechnik              */
/* APL / RESET   		              */
/* Version 1.0.0                      */
/* 2011-06-07                         */
/*                                    */
/**************************************/
////////////////////////////////////////



/***************   USART_INIT   ***************/


USART_INIT:

	push R16
	push R17


	; Set baud rate (2400 BAUD)

	clr R16

	ldi R17,0xD0

	out UBRRH, R16

	out UBRRL, R17



	; Set frame format: 8data, 2stop bit

	ldi R16, (1<<URSEL)|(1<<USBS)|(3<<UCSZ0)

	out UCSRC,R16


	pop R17
	pop R16

ret



/****************   ADC_INIT   ***************/

ADC_INIT:

	push R16
	ldi  R16, (1 << REFS0)|(1 << ADLAR)|(1 << MUX1)
	out  ADMUX,R16
	ldi  R16, (1 << ADEN)|(1 << ADPS2);|(1 << ADPS1) | (1 << ADPS0)  	; Prescaler 128
	out  ADCSRA, R16
	cbi  DDRC,2
	cbi  DDRC,3
	clr  adcc
	inc  adcc
	clr  ml
	clr  mr
	clr  zel
	clr  zer
	clr  diff
	pop  R16

ret



MOTOR_INIT:

	push R16
	
	in  R16,DDRB											; Ports initialisieren
	ori R16,0b00110110
	out DDRB,R16
	in  R16,DDRD
	ori R16,0b00110000
	out DDRD,R16
	sbi PORTB,1
	sbi PORTB,2
	ldi R16, (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1)	; for PWM (8-Bit PWM) on OC1A & OC1B
	out TCCR1A, R16
	ldi R16, (1 << CS11)
	out TCCR1B, R16



	pop  R16

ret



TIMER0_Init:

	push R16								; Register sichern
	ldi  R16, (1 << CS02) | (1 << CS00) 	; Prescaler des Timer0 auf 1024 setzen
	out  TCCR0,R16
	pop  R16								; Register wiederherstellen

ret
