////////////////////////////////////////
/**************************************/
/*                                    */
/* Michael Goldbuch; Jrgen Dffinger */
/*                                    */
/* Mikroprozessortechnik              */
/* APL / TRANSMIT		              */
/* Version 1.0.0                      */
/* 2011-06-07                         */
/*                                    */
/**************************************/
////////////////////////////////////////



/**************   TRANSMIT   ****************/

TRANSMIT:

	push  R16				; Register sichern
	push  count
	push  ZH				; Z-Pointer sichern
	push  ZL
	
	tst   anz				; Prfen ob ein Zeichen zu senden ist
	breq  TRANSMIT_2		; Wenn kein Zeichen zu senden ist dann weiter bei TRANSMIT_2
	rcall TRANSMIT_ENABLE	; Senden freigeben - Enpfangen sperren
	mov   count,anz			; Zeichenzhler setzen
	ldi   ZH,high(text)		; Z-Pointer setzen auf Startadresse
	ldi   ZL,low(text)

	TRANSMIT_1:

	sbis UCSRA,UDRE			; Prfen ob Sendepuffer frei ist
	rjmp TRANSMIT_1			; wenn nicht dann warten
	ld   R16,Z+				; Zu sendes Zeichen laden
	out  UDR,R16			; und in Sendepuffer schreiben
	dec  count				; Zhler dekrementieren
	brne TRANSMIT_1			; wenn Zhler nicht gleich 0 ist, dann weiter Zeichen senden

	TRANSMIT_2:

	pop   ZL				; Z-Pointer wiederherstellen
	pop   ZH
	pop   count				; Register wiederherstellen
	pop   R16

ret



/***************   TRANSMIT_ENABLE   ***************/

TRANSMIT_ENABLE:

	cbi  UCSRB,RXEN		; Receive disable
	cbi  UCSRB,RXCIE	; Receive Complete Interrupt disable
	sbi  UCSRB,TXEN		; Transmit enable
	cbi  UCSRB,TXCIE	; Transmit Complete Interrupt enable

ret
