/**************************************/
/*                                    */
/* Michael Goldbuch; Jrgen Dffinger */
/*                                    */
/* Mikroprozessortechnik              */
/* APL / Definitionen                 */
/* Version 1.0.0                      */
/* 2011-06-07                         */
/*                                    */
/**************************************/
////////////////////////////////////////



/***************   Definitionen   ****************/

.DSEG

	text:	.Byte 250		; Startadresse des zu bertragenden Arrays
	pdr1:	.Byte 8			; Werte fr Regler 1
	pdr2:	.Byte 8			; Werte fr Regler 2

.CSEG

.def	rx_seq 	=  	R0		; bei 0x00 wurde keine und bei 0xFF wurde die Start-/Endsequence empfangen
.def	adcc	=	R5		; Zhler fr die Sensorenmesung - verwendung in ISR ADCI
.def  	zer		=	R6		; Zwischenergebnis rechter Sensor
.def  	zel		=	R7		; Zwischenergebnis linker Sensor
.def    diff	=	R8		; Differenz aus Messwert rechter Sensor und linker Sensor
.def    mr		=	R9		; Messwert rechter Sensor
.def    ml		=	R10		; Messwert linker Sensor
.def    timeout =	R11		; bei 0x00 liegt kein und bei 0xFF liegt ein Timeout vor
.def	anz		=	R12		; Anzahl der empfangenen Zeichen
.def	t_count	=	R13		; Timeout - Zhler; zhlt die Anzahl Timer-Interrupts (nach 62 liegt ein Timeout vor)
.def    sr		=	R14		; Geschwindigkeit rechter Motor
.def    sl		= 	R15		; Geschwindigkeit linker Motor	
.def	count	=	R17		; allgemein zum zhlen

.equ  speed		= 	160		; Standardgeschwindigkeit
.equ  wartezeit = 	250		; Wartezeit, welche dem Timer bergeben wird
.equ  drift	    = 	252		; Ausgeich zwischen rechten und linken Sensor
.equ  messwert  = 	0



